MODULE PLA_Ver2;
FROM StreamFile IMPORT ChanId, Open, read, Close, OpenResults;
FROM TextIO IMPORT ReadString, WriteLn, WriteString, WriteChar, SkipLine;
FROM IOResult IMPORT ReadResult, ReadResults;
FROM StdChans IMPORT StdInChan, StdOutChan;
FROM WholeIO  IMPORT WriteInt, WriteCard;
IMPORT Strings;

TYPE line = ARRAY[0..120] OF CHAR;
     AllLines = ARRAY [1..1000] OF line;

     word = ARRAY[0..50] OF CHAR;
     WordFreq = RECORD
                freq   : INTEGER;
                aword   : word;
            END;
     AllWords = ARRAY [1..1000] OF WordFreq;

PROCEDURE Read(VAR stdOut: ChanId; VAR document: AllLines; VAR numlines: INTEGER);

  VAR
    i: INTEGER;
    res : OpenResults;
    inputline: line;
    infile: ChanId;

  BEGIN
  
    (* The first part of the code reads all lines from the file *)
    (* into inputline and stores them in the document array *)
    Open (infile, "test2.txt", read, res);
    IF res = opened
      THEN
        i := 1;
        REPEAT  (* Collect the numbers from the file *)
          ReadString (infile, inputline);
          WriteString (stdOut, inputline);
          IF ReadResult (infile) = allRight
            THEN
              SkipLine (infile);
              (* NOW PROCESS THE LINE TO FIND WORDS *)
              document[i]:=inputline;
              WriteLn (stdOut);
              i:=i+1;
              ELSE
                SkipLine (infile);
                (* NOW PROCESS THE LINE TO FIND WORDS *)
                document[i]:=inputline;
                WriteLn (stdOut);
            END;  (* if *)
          
        UNTIL (ReadResult (infile) # allRight);
       Close (infile);
       WriteLn (stdOut);
      ELSE
       WriteString (stdOut,"Sorry, couldn't open the file");
       WriteLn (stdOut);
      END; (* if *)
    numlines :=i-1; (* i gets incremented for EOF line*)
      
      
  END Read;
    
PROCEDURE WFF(VAR wordsindoc: AllWords; VAR document: AllLines;
                VAR numwords: INTEGER; VAR numlines: INTEGER; VAR wordindex: INTEGER);
VAR
    i, j, k : INTEGER;
    c: INTEGER;
    charval : INTEGER;
    currWord: word;
    isWordInList: BOOLEAN;
  
BEGIN
  (* The code part of the code cycles through document array *)
      (* in order to identify words in each line*)
      numwords:=0;
      wordindex := 1;
      FOR i:=1 TO numlines DO 
        j:=0; k:=0;
        FOR c := 0 TO 50 DO
          currWord[c] := '';
        END;
        WHILE ORD(document[i][j]) <> 0
        DO
         charval := ORD(document[i][j]);
         IF ((charval >= 48) AND (charval < 58)) OR
            ((charval >= 65) AND (charval < 91)) OR
            ((charval >= 97) AND (charval < 123)) OR
            ((charval = 45)) OR ((charval=95))
           THEN (* is it a number or upper/lower case char *)
             currWord[k] := document[i][j];
             (*wordsindoc[wordindex].aword[k] := document[i][j];*)
             k:=k+1;
           ELSE (* end of word *)
             isWordInList := FALSE;
             FOR c := 1 TO wordindex DO
               IF (Strings.Equal(wordsindoc[c].aword, currWord) = TRUE)
                  AND (Strings.Equal(currWord, "") = FALSE)
                 THEN
                   wordsindoc[c].freq := wordsindoc[c].freq + 1;
                   numwords:=numwords+1;
                   isWordInList := TRUE;
                 END;
             END;
              IF (isWordInList = FALSE) AND (Strings.Equal(currWord, "") = FALSE)
                THEN
                  wordsindoc[wordindex].aword := currWord;
                  wordsindoc[wordindex].freq := 1;
                  wordindex:=wordindex+1;
                  numwords:=numwords+1;
              END;
             k:=0;
             FOR c := 0 TO 50 DO
              currWord[c] := '';
             END;
           END;
         j:=j+1;
        END;
        IF (k > 0)
                 THEN
                   FOR c := 1 TO wordindex DO
                   IF (Strings.Equal(wordsindoc[c].aword, currWord) = TRUE)
                     AND (Strings.Equal(currWord, "") = FALSE)
                     THEN
                    wordsindoc[c].freq := wordsindoc[c].freq + 1;
                    numwords:=numwords+1;
                    isWordInList := TRUE;
                    END;
                   END;
                   IF (isWordInList = FALSE) AND (Strings.Equal(currWord, "") = FALSE)
                     THEN
                      wordsindoc[wordindex].aword := currWord;
                      wordsindoc[wordindex].freq := 1;
                      wordindex:=wordindex+1;
                      numwords:=numwords+1;
                      END;
                 END;
      END;
      (* numwords:=numwords-1;
       *)
  END WFF;    

PROCEDURE SortAndPrint(VAR stdOut: ChanId; wordsindoc: AllWords; wordindex: INTEGER);
VAR
  i: INTEGER;
  sortedWordIndex: INTEGER;
  addIndex: INTEGER;
  temp: WordFreq;
BEGIN
  sortedWordIndex := 1;
  WHILE wordindex > sortedWordIndex DO
    addIndex := sortedWordIndex;
    FOR i := sortedWordIndex TO wordindex - 1 DO
      IF Strings.Compare(wordsindoc[addIndex].aword, wordsindoc[i].aword) = Strings.greater THEN
        addIndex := i;
      END;
    END;
    temp := wordsindoc[sortedWordIndex];
    wordsindoc[sortedWordIndex] := wordsindoc[addIndex];
    wordsindoc[addIndex] := temp;
    sortedWordIndex := sortedWordIndex + 1;
  END;
  
  FOR i := 1 TO sortedWordIndex - 1 DO
          WriteString(stdOut, wordsindoc[i].aword);
          WriteString(stdOut, ": ");
          WriteInt(stdOut, wordsindoc[i].freq, 3);
          WriteLn(stdOut);
        END;
END SortAndPrint;
    
VAR
  stdOut, stdIn : ChanId;
  document: AllLines;
  wordsindoc: AllWords;    
  numwords: INTEGER;
  numlines: INTEGER;
  wordindex: INTEGER;
    
BEGIN
  stdOut := StdOutChan(); (* to force screen output *)
  stdIn := StdInChan(); (* to force keyboard input *)
  Read(stdOut, document, numlines);    
  WFF(wordsindoc, document, numwords, numlines, wordindex);
  SortAndPrint(stdOut, wordsindoc, wordindex);
  
  WriteLn(stdOut);
  WriteString(stdOut, "Num Words: ");
  WriteInt(stdOut, numwords, 3);
  WriteLn(stdOut);
END PLA_Ver2.